void wait_until_move(void)
{
	Flag_motor=0xff;
	while(Flag_motor);
}

void absolute_deg(int no, int deg, int speed)
{
	Deg(no)=(int)((long)(deg)*(long)(Factor(no))>>10);
	Speed(no)=(int)((long)(speed)*(long)(Factor(no))>>10);
}

void same_absolute_deg(byte flag, byte dir, int deg, int speed)
{
	int i;

	wait_until_move();
	for(i=0; i<8; i++)
	{
		if( flag&(1<<i) )
		{
			if(dir&(1<<i))	absolute_deg(i, deg, speed);
			else			absolute_deg(i, -deg, speed);
		}
	}
}

void relative_deg(int no, int deg, int speed)
{
	int temp;

	temp=(int)(((long)(Deg(no))<<10)/(long)(Factor(no)));
	deg+=temp;
	Deg(no)=(int)((long)(deg)*(long)(Factor(no))>>10);
	Speed(no)=(int)((long)(speed)*(long)(Factor(no))>>10);
}

void same_relative_deg(byte flag, byte dir, int deg, int speed)
{
	int i;

	wait_until_move();
	for(i=0; i<8; i++)
	{
		if(flag&(1<<i))
		{
			if(dir&(1<<i))	relative_deg(i, deg, speed);
			else			relative_deg(i, -deg, speed);
		}
	}
}

void creep1_motion(int speed)
{
	same_relative_deg(S0|S2, 0, 40, speed);
	same_relative_deg(S0, 0, 60, speed);
	same_relative_deg(S2, S2, 20, speed);
	same_relative_deg(S0|S2|S6, S0|S2|S6, 20, speed);
	same_relative_deg(S0|S6, S0|S6, 40, speed);

	same_relative_deg(S4, S4, 30, speed);
	same_relative_deg(S6, 0, 30, speed);

	same_relative_deg(S4|S6, 0, 10, speed);
	same_relative_deg(S6, 0, 10, speed);
	same_relative_deg(S4|S6, 0, 20, speed);
	same_relative_deg(S0, S0, 30, speed);

	same_relative_deg(S0|S6, S0|S6, 10, speed);
	same_absolute_deg(S0|S2|S4|S6, 0, 0, speed);
}

void head_up_motion(int speed)
{
	same_absolute_deg(S4, S4, 60, speed);
	same_absolute_deg(S6, S6, 60, speed);
	delay_1ms(1000);

	same_absolute_deg(S6, S6, -30, speed*2);
	same_absolute_deg(S6, S6, 30, speed*2);
	same_absolute_deg(S6, S6, -30, speed*2);
	same_absolute_deg(S6, S6, 60, speed*2);
	delay_1ms(1000);

	same_absolute_deg(S0|S2|S4|S6, 0, 0, speed);
}

void creep2_motion(int speed)
{
	same_relative_deg(S4|S6, S4|S6, 40, speed);
	same_relative_deg(S6, S6, 60, speed);
	same_relative_deg(S4, 0, 20, speed);
	same_relative_deg(S0|S4|S6, 0, 20, speed);
	same_relative_deg(S0|S6, 0, 40, speed);

	same_relative_deg(S2, 0, 30, speed);
	same_relative_deg(S0, S0, 30, speed);

	same_relative_deg(S0|S2, S0|S2, 10, speed);
	same_relative_deg(S0, S0, 10, speed);
	same_relative_deg(S0|S2, S0|S2, 20, speed);
	same_relative_deg(S6, 0, 30, speed);

	same_relative_deg(S0|S6, 0, 10, speed);
	same_absolute_deg(S0|S2|S4|S6, 0, 0, speed);
}

void tail_up_motion(int speed)
{
	same_absolute_deg(S2, 0, 60, speed);
	same_absolute_deg(S0, 0, 60, speed);
	delay_1ms(1000);

	same_absolute_deg(S0, 0, -30, speed*2);
	same_absolute_deg(S0, 0, 30, speed*2);
	same_absolute_deg(S0, 0, -30, speed*2);
	same_absolute_deg(S0, 0, 60, speed*2);
	delay_1ms(1000);

	same_absolute_deg(S0|S2|S4|S6, 0, 0, speed);
}

